/* list.c   list operators
     based on LISP-like function

	 for project som-c	 27 Dec 2003
	 reimplement without struct  15 Jan 2004
*/

#include "compile.h"

#define   CELLPTR 		10    // min pointer to acell

#define   PRIVATE		static

/*
typedef struct {
	int head;
	int tail;
} acell;
*/

//PRIVATE acell cell[MAXCELL];
//PRIVATE int freecell = CELLPTR;
PRIVATE int *cell = &M[0];
PRIVATE int freecell = MAXCS;

/*
PRIVATE void setcar(int a, int value){ cell[a].head = value; }
PRIVATE void setcdr(int a, int value){ cell[a].tail = value; }
PRIVATE int getcar(int a){ return cell[a].head; }
PRIVATE int getcdr(int a){ return cell[a].tail; }
*/
PRIVATE void setcar(int a, int value){ cell[a] = value; }
PRIVATE void setcdr(int a, int value){ cell[a+1] = value; }
PRIVATE int getcar(int a){ return cell[a]; }
PRIVATE int getcdr(int a){ return cell[a+1]; }

PRIVATE int newcell(void){
	int a;
	a = freecell;
	if( a == NIL ) seterror("out of memory cells");
	freecell = getcdr(a);
	setcdr(a, NIL);
	return a;
}

int countcell(void){
	int a, k;
	k = 0;
	a = freecell;
	while ( a != NIL ){
		k++;
		a = getcdr(a);
	}
	return k;
}

int islist(int x){ return getcar(x) >= CELLPTR; }
int isatom(int x){ return getcar(x) < CELLPTR; }

int newatom(int type, int value){
	int a;
	a = newcell();
	setcar(a,type);
	setcdr(a,value);
	return a;
}

void initcell(void){
	int i;
	for(i=MAXMEM-2; i>=MAXCS; i-=2){
		setcar(i,0);
		setcdr(i,i+2);
	}
	setcdr(MAXMEM-2,NIL);
	freecell = MAXCS;
}

int list(int a){
	int b;
	b = newcell();
	setcar(b,a);
	return b;
}

int cons(int a, int l){
	int b;
	b = newcell();
	setcdr(b,l);
	setcar(b,a);
	return b;
}
/*
int car(int x){
	if( islist(x) )
		return getcar(x);
	else
		return NIL;
}

int cdr(int x){
	if( islist(x) )
		return getcdr(x);
	else
		return NIL;
}
*/
int car(int x){ return getcar(x); }
int cdr(int x){ return getcdr(x); }

int append(int l, int x){
	int a, b;
	if( x == NIL ) return l;
	a = l;
	while( (b = cdr(a)) != NIL )
		a = b;
	setcdr(a,list(x));
	return l;
}

void prlist(int a){
	if( a == NIL ) return;
	if( isatom(a) ){
		switch(getcar(a)){
		case SP: printf("NIL "); break;
		case OPER: prtok(getcdr(a)); break;
		case NUM: printf("%d ",getcdr(a)); break;
		case GNAME: printf("%s ",getName(getcdr(a))); break;
		case LNAME: printf("#%d ",getcdr(a)); break;
		case STRING: prstr(getcdr(a)); break;
		}
	}else{
		printf("(");
		while( a != NIL ){
			prlist(car(a));
			a = cdr(a);
		}
		printf(")");
	}
}

/*
void testlist(){
	int a, b, c, d, e, f;
	initcell();
	a = newatom(1,10);
	b = newatom(1,20);
	c = list(b);
	d = cons(a,c);
	d = list(d);
	e = newatom(1,30);
	f = cons(e,d);
	f = append(d,e);
	prlist(f);
	prlist(car(f));
	prlist(cdr(f));
	prlist(car(cdr(f)));
	prlist(cdr(cdr(f)));
}
*/
